star  struc
  starc db 0
  starxs dw 0
  starys dw 0
  starcx dw 0
  starcy dw 0
  starx  dw 0
  stary  dw 0
star  ends
starlen equ 13
starmax equ 100
cseg segment para public 'CODE'
assume cs:cseg,ds:cseg,es:cseg
   org 100h
entry:jmp start
random  dw  1234h
r2   dw  03fe1h
star_types db '*'
vbuff dw 0b800h
start:
    call zero_stars
    mov  cx,200
r_loop:
    push cx
    call randomize
    call find_free_star
    jc   m_stars
    call init_star
m_stars:
    mov  cx,starmax
    mov  si,offset stars
m_loop:
    push cx
    call mov_star
    pop  cx
    add  si,starlen
    loop m_loop
    pop  cx
    loop  r_loop
    mov   ah,1
    int   16h
    jnz   exit_stars
    jmp   start
exit_stars:
    int  20h
mov_star:
; moves the star in si
    push  es
    mov   es,vbuff
    cmp   ds:[si].starc,0
    jne   ms_0
    pop   es
    ret
ms_0:
; fix old position
    cmp  ds:[si].starcx,0
    jne  ms_1
    cmp  ds:[si].starcy,0
    je   ms_2
ms_1:
    mov  ax,ds:[si].starcy
    mov  cx,80
    mul  cx
    add  ax,ds:[si].starcx
    shl  ax,1
    mov  di,ax
    mov  ax,0720h
    stosw
ms_2:
; here calculate the new position of the star
; x and y are distances from the upper left hand corner
; xs and ys are speeds from center
    mov  ax,ds:[si].starx
    add  ax,ds:[si].starxs
    mov  ds:[si].starx,ax
    mov  ax,ds:[si].stary
    add  ax,ds:[si].starys
    mov  ds:[si].stary,ax
; now convert to cx and cy
    mov  ax,ds:[si].starx
    mov  dx,0
    mov  cx,80
    mul  cx
    mov  cx,1000h
    idiv  cx
    mov  ds:[si].starcx,ax
    cmp  ax,80
    jg   bad_star
    cmp  ax,0
    jl   bad_star
    mov  ax,ds:[si].stary
    mov  dx,0
    mov  cx,25
    mul  cx
    mov  cx,1000h
    idiv  cx
    mov  ds:[si].starcy,ax
    cmp  ax,25
    jg   bad_star
    cmp  ax,0
    jl   bad_star
; now put it
    mov  ax,ds:[si].starcy
    mov  cx,80
    mul  cx
    add  ax,ds:[si].starcx
    shl  ax,1
    mov  di,ax
    mov  ah,7
    mov  al,ds:[si].starc
    stosb
    mov  ax,ds:[si].starxs
    shr  ax,1
    cbw
    shr  ax,1
    cbw
    shr  ax,1
    cbw
    shr  ax,1
    cbw
    add  ds:[si].starxs,ax
    mov  ax,ds:[si].starys
    shr  ax,1
    cbw
    shr  ax,1
    cbw
    shr  ax,1
    cbw
    shr  ax,1
    cbw
    add  ds:[si].starys,ax
    pop  es
    ret
bad_star:
    mov   ds:[si].starc,0
    mov   ds:[si].starcx,0
    mov   ds:[si].starcy,0
    pop   es
    ret
init_star:
; di points to star
    call  randomize
    and   ax,3
    cmp   ax,4
    jle   is_0
    dec   ax
    dec   ax
is_0:
    mov   bx,ax
    mov   al,star_types[bx]
    mov   ds:[di].starc,al
    call  randomize
    and   ax,0fffh
    inc   ax
    mov   ds:[di].starx,ax
    call  randomize
    and   ax,0fffh
    inc   ax
    mov   ds:[di].stary,ax
re_rand1:
    call  randomize
    mov   cx,ax
    and   cx,3ffh
    add   cx,100
    and   cx,3ffh
    inc   cx
    mov   ax,ds:[di].starx
    mov   dx,0
    sub   ax,800h
    sbb   dx,0
    idiv   cx
    and   ax,0fff8h
    mov   ds:[di].starxs,ax
    mov   ax,ds:[di].stary
    mov   dx,0
    sub   ax,800h
    sbb   dx,0
    idiv   cx
    and   ax,0fffch
    mov   ds:[di].starys,ax
    mov   ds:[di].starcx,0
    mov   ds:[di].starcy,0
    ret
find_free_star:
    mov  cx,starmax
    mov  di,offset stars
ffs_loop:
    cmp  ds:[di].starc,0
    je   found_star
    add  di,starlen
    loop ffs_loop
    stc
    ret
found_star:
    clc
    ret
randomize:
    mov  ax,random
    add  ax,1013h
    mov  cx,r2
    mul  cx
    shr  ax,1
    adc  dx,5
    xor  cx,dx
    add  cx,3030h
    adc  ax,0ffffh
    mov  r2,cx
    mov  dx,0
    or   cx,7070h
    div  cx
    add  ax,5052h
    adc  dx,34
    xor  ax,dx
    xchg al,ah
    shr  ax,1
    xor  ax,6c84h
    xor  cx,dx
    xchg cl,ch
    mul  cx
    and  dx,ax
    xor  cx,dx
    mov  dx,0
    or   cx,7070h
    div  cx
    xor  ax,dx
    xchg al,ah
    mov  random,ax
    ret
zero_stars:
    lea  di,stars
    mov  ax,0
    mov  cx,starmax*starlen/2
    cld
rep stosw
    mov  cx,4000
    ret
stars db 0
cseg ends
     end entry
